<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../../mixins';
import SurveyQuote from '../2022/survey-quote.vue';
import ColumnGroup from './column-group.vue';
import SurveyHero from './survey-hero.vue';
import StatsGrid from './stats-grid.vue';
import SurveyStatBarsSection from './survey-stat-bars-section.vue';
import SurveyBanner from './survey-banner.vue';
import SurveyGlowPills from './survey-glow-pills.vue';
import SurveyQuoteCarousel from './survey-quote-carousel.vue';
import SurveyRegionBubbles from './survey-region-bubbles.vue';
import SurveyRoleBubbles from './survey-role-bubbles.vue';
import { SolutionsHero } from '~/components/solutions';

export default Vue.extend({
  name: 'SurveyTabs',
  components: {
    SolutionsHero,
    ColumnGroup,
    SurveyQuote,
    SurveyHero,
    StatsGrid,
    SurveyStatBarsSection,
    SurveyGlowPills,
    SurveyBanner,
    SurveyQuoteCarousel,
    SurveyRegionBubbles,
    SurveyRoleBubbles,
  },
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Array,
      required: true,
      default() {
        return [];
      },
    },
  },
  data() {
    return {
      tabs: [],
      firstTab: null,
      lastTab: null,
      tabpanels: [],
      selectedTab: 0,
    };
  },
  mounted() {
    const hash = window.location.hash.slice(1);
    const ids = this.data
      .map((block) => block.id)
      .filter((id) => id !== undefined);
    const indexOfTab = ids.indexOf(hash);

    if (indexOfTab !== -1) {
      this.selectedTab = indexOfTab;
      document.getElementById('survey-tabs-bar')?.scrollIntoView();
    }
  },
  methods: {
    onTabChange(value: number) {
      this.selectedTab = value;
      document.getElementById('survey-tabs-bar')?.scrollIntoView();
    },

    onSelectChange(event: Event) {
      const ids = this.data
        .map((block) => block.id)
        .filter((id) => id !== undefined);

      const target = event.target as HTMLInputElement;
      const indexOfTab = ids.indexOf(target.value);

      if (indexOfTab !== -1) {
        this.selectedTab = indexOfTab;
      }
    },
  },
});
</script>

<template>
  <section class="survey-tabs">
    <div id="survey-tabs-bar" class="survey-tabs__wrapper">
      <div v-if="isMobile">
        <SlpContainer class="survey-tabs__select-wrapper">
          <div class="survey-tabs__select">
            <select
              id="sections"
              name="sections"
              @change="onSelectChange($event)"
            >
              <option value="">Jump to a section</option>
              <option
                v-for="(tab, tabIndex) in data"
                :key="tab.header + `-${tabIndex}`"
                :value="tab.id"
                :disabled="tab.disabled"
              >
                {{ tab.header }}
              </option>
            </select>
          </div>
        </SlpContainer>
        <div
          v-for="(tabContent, tabContentIndex) in data"
          v-show="tabContentIndex === selectedTab"
          :id="`tabpanel-${tabContentIndex}`"
          :key="`tab-content-${tabContentIndex}`"
          role="tabpanel"
          tabindex="0"
          :aria-labelledby="`tab-${tabContentIndex}`"
        >
          <component
            :is="component.name"
            v-for="(component, index) in tabContent.components"
            :key="component.name + `-${index}`"
            class="survey-tabs__section"
            :class="component.data.variant"
            :data="component.data"
          />
        </div>
      </div>
      <div v-else>
        <div class="survey-tabs__options">
          <div v-if="data.length > 1" class="survey-tabs__options-wrapper">
            <div
              class="survey-tabs__tabs"
              role="tablist"
              aria-labelledby="tablist-1"
              :cols="10"
            >
              <button
                v-for="(tab, tabIndex) in data"
                :key="tab.header"
                ref="tab"
                type="button"
                role="tab"
                :disabled="tab.disabled"
                aria-selected="true"
                :aria-controls="`tabpanel-${tabIndex}`"
                class="survey-tabs__tab"
                :class="
                  selectedTab == tabIndex ? 'survey-tabs__tab--active' : ''
                "
                @click="onTabChange(tabIndex)"
              >
                <SlpTypography variant="body2" tag="p">
                  <span>Report {{ tabIndex + 1 }}</span>
                  {{ tab.header }}
                </SlpTypography>
              </button>
            </div>
            <div class="survey-tabs__tabs-cta">
              <SlpButton variant="tertiary" :href="'#download'"
                >Download the full reports</SlpButton
              >
            </div>
          </div>
        </div>
        <div
          v-for="(tabContent, tabContentIndex) in data"
          v-show="tabContentIndex === selectedTab"
          :id="`tabpanel-${tabContentIndex}`"
          :key="`tab-content-${tabContentIndex}`"
          role="tabpanel"
          tabindex="0"
          :aria-labelledby="`tab-${tabContentIndex}`"
        >
          <component
            :is="component.name"
            v-for="(component, index) in tabContent.components"
            :key="component.name + `-${index}`"
            class="survey-tabs__section"
            :class="component.data.variant"
            :data="component.data"
          />
        </div>
      </div>
    </div>
  </section>
</template>

<style lang="scss" scoped>
.survey-tabs {
  &__tab {
    color: $color-secondary-300;
    border: none;
    cursor: pointer;
    padding: $spacing-24;
    text-align: left;
    width: 100%;

    @media (min-width: $breakpoint-md) {
      width: auto;
    }

    &:hover {
      border-bottom: 3px solid $color-text-link-100;
    }

    &--active {
      border-bottom: 3px solid $color-text-link-100;

      p {
        font-weight: 600;
      }
    }

    span {
      font-size: 14px;
      font-weight: 600;
      display: block;
      font-family: 'GitLab Sans', sans-serif;
    }

    &:disabled {
      pointer-events: none;
      color: $color-surface-500;
    }
  }

  &__select {
    select {
      width: 100%;
      padding: $spacing-8;
      font-family: 'GitLab Sans', sans-serif;
      font-size: $font-size-default;
      font-weight: $font-weight-normal;
      color: $color-text-200;
      border-radius: $border-radius-4;
      line-height: $line-height-body-1;
    }
    &-wrapper {
      position: sticky !important;
      top: 150px;
      z-index: 100;
    }
  }

  &__options {
    width: 100%;
    position: -webkit-sticky; /* Safari */
    position: sticky;
    top: 84px;
    z-index: 10;
    margin-bottom: 58px;

    &-wrapper {
      display: flex;
      width: 100%;
      background-color: $color-surface-50;
      justify-content: space-between;
    }
  }
  &__section {
    margin-top: $spacing-64;
    overflow-x: clip;
    &:last-of-type {
      padding-bottom: $spacing-32;
    }
  }
  &__tabs {
    background-color: $color-surface-800;
    flex-direction: column;
    z-index: 10;
    position: relative;
    width: 100%;

    &-cta {
      display: flex;
      align-items: center;
      min-width: fit-content;
      background-color: $color-surface-800;

      a {
        color: $color-text-link-100;
        text-decoration: none;

        &:hover {
          text-decoration: none;
        }
      }
    }

    @media (min-width: $breakpoint-sm) {
      display: flex;
    }
    @media (min-width: $breakpoint-md) {
      display: flex;
      flex-direction: initial;
    }
    @media (min-width: $breakpoint-lg) {
      display: block;
    }
  }
}
</style>
